import { FlexValue, FlexValueSync, IFlexOptions } from './types';
export declare class Flex {
    /**
     * Handles:
     * - synchronous values and callbacks;
     * - asynchronous values and callbacks.
     */
    static get<T>(value: FlexValue<T>, options?: IFlexOptions<T>): Promise<T>;
    /**
     * Handles synchronous values and callbacks.
     * Reports error on everything asynchronous.
     */
    static getSync<T>(value: FlexValueSync<T>, options?: IFlexOptions<T>): T;
}
